
#include "ps2.h"

//#define READONLY __attribute__((section (".eeprom")))
//#define READONLY code
#define READONLY static const



#define PREFIX_E0 0x100



READONLY unsigned short encodetable[] = {
	// 0x00
	0x00,
	0x0e,
	0x16,
	0x1e,
	0x26,
	0x25,
	0x2e,
	0x36,
	0x3d,
	0x3e,
	0x46,
	0x45,
	0x4e,
	0x55,
	0x6a,
	0x66,

	// 0x10
	0x0d,
	0x15,
	0x1d,
	0x24,
	0x2d,
	0x2c,
	0x35,
	0x3c,
	0x43,
	0x44,
	0x4d,
	0x54,
	0x5b,
	0x5d,
	0x58,
	0x1c,

	// 0x20
	0x1b,
	0x23,
	0x2b,
	0x34,
	0x33,
	0x3b,
	0x42,
	0x4b,
	0x4c,
	0x52,
	0x5d,
	0x5a,
	0x12,
	0x61,
	0x1a,
	0x22,

	// 0x30
	0x21,
	0x2a,
	0x32,
	0x31,
	0x3a,
	0x41,
	0x49,
	0x4a,
	0x51,
	0x59,
	0x14,
	0x00,
	0x11,
	0x29,
	0x11 | PREFIX_E0,
	0x00,

	// 0x40
	0x14 | PREFIX_E0,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x70 | PREFIX_E0,
	0x71 | PREFIX_E0,
	0x00,
	0x00,
	0x6b | PREFIX_E0,

	// 0x50
	0x6c | PREFIX_E0,
	0x69 | PREFIX_E0,
	0x00,
	0x75 | PREFIX_E0,
	0x72 | PREFIX_E0,
	0x7d | PREFIX_E0,
	0x7a | PREFIX_E0,
	0x00,
	0x00,
	0x74 | PREFIX_E0,
	0x77,
	0x6c,
	0x6b,
	0x69,
	0x00,
	0x4a | PREFIX_E0,

	// 0x60
	0x75,
	0x73,
	0x72,
	0x70,
	0x7c,
	0x7d,
	0x74,
	0x7a,
	0x71,
	0x7b,
	0x79,
	0x00,
	0x5a | PREFIX_E0,
	0x00,
	0x76,
	0x00,

	// 0x70
	0x05,
	0x06,
	0x04,
	0x0c,
	0x03,
	0x0b,
	0x83,
	0x0a,
	0x01,
	0x09,
	0x78,
	0x07,
	0x00,
	0x7e,
	0x00,
	0x00,
	
	// 0x80
	0x00,
	0x00,
	0x00,
	0x67,
	0x64,
	0x13,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
};


READONLY unsigned char _make124_default[] =			"\xe0\x12\xe0\x7c";
READONLY unsigned char _make124_shift_ctrl[] =		"\xe0\x7c";
READONLY unsigned char _make124_alt[] =				"\x84";

READONLY unsigned char _break124_default[] =		"\xe0\xf0\x7c\xe0\xf0\x12";
READONLY unsigned char _break124_shift_ctrl[] =		"\xe0\xf0\x7c";
READONLY unsigned char _break124_alt[] =			"\xf0\x84";

READONLY unsigned char _make126_default[] =			"\xe1\x14\x77\xe1\xf0\x14\xf0\x77";
READONLY unsigned char _make126_ctrl[] =			"\xe0\x7e\xe0\xf0\x7e";

READONLY unsigned char _e0_f0_12[] = "\xe0\xf0\x12";
READONLY unsigned char _e0_12[] = "\xe0\x12";

static void outputs(const unsigned char *p, void (*output)(unsigned char c, void *cookie), void *cookie)
{
	while (*p) output(*p++, cookie);
}

int ps2encode(unsigned char number, unsigned short keyflag, void (*output)(unsigned char c, void *cookie), void *cookie)
{
#define OUTPUT(C) output(C, cookie)
#define OUTPUTS(S) outputs(S, output, cookie);

	if (number == 124) {
		if (keyflag & KEYFLAG_MAKE) {
			if (keyflag & (KEYFLAG_SHIFT | KEYFLAG_CTRL)) {
				OUTPUTS(_make124_shift_ctrl);
			} else if (keyflag & KEYFLAG_ALT) {
				OUTPUTS(_make124_alt);
			} else {
				OUTPUTS(_make124_default);
			}
		} else {
			if (keyflag & (KEYFLAG_SHIFT | KEYFLAG_CTRL)) {
				OUTPUTS(_break124_shift_ctrl);
			} else if (keyflag & KEYFLAG_ALT) {
				OUTPUTS(_break124_alt);
			} else {
				OUTPUTS(_break124_default);
			}
		}
	} else if (number == 126) {
		if (keyflag & KEYFLAG_MAKE) {
			if (keyflag & KEYFLAG_CTRL) {
				OUTPUTS(_make126_ctrl);
			} else {
				OUTPUTS(_make126_default);
			}
		}
	} else {
		unsigned short keycode = 0;
		if (number < 0x90) keycode = encodetable[number];
		if (keycode) {
			if (number >= 75 && number <= 89) {
				if (keyflag & KEYFLAG_MAKE) {
					if (keyflag & KEYFLAG_SHIFT) {
						OUTPUTS(_e0_f0_12);
					} else if (keyflag & KEYFLAG_NUMLOCK) {
						OUTPUTS(_e0_12);
					}
				}
			}

			if (keycode & PREFIX_E0) output(0xe0, cookie);
			if (!(keyflag & KEYFLAG_MAKE)) output(0xf0, cookie);
			OUTPUT(keycode);

			if (number >= 75 && number <= 89) {
				if (!(keyflag & KEYFLAG_MAKE)) {
					if (keyflag & KEYFLAG_SHIFT) {
						OUTPUTS(_e0_12);
					} else if (keyflag & KEYFLAG_NUMLOCK) {
						OUTPUTS(_e0_f0_12);
					}
				}
			}
		}
	}
#undef OUTPUT
#undef OUTPUTS
}



